Git 1.7.11-rc0
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
ecda0723 3# git-submodules.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
d27b876b 8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
9db31bdf 11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
adc54235 12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 13 or: $dashless [--quiet] foreach [--recursive] <command>
1d5bec8b 14 or: $dashless [--quiet] sync [--] [<path>...]"
8f321a39 15OPTIONS_SPEC=
70c7ac22 16. git-sh-setup
d0ad8251 17. git-sh-i18n
98fcf840 18. git-parse-remote
70c7ac22
LH
19require_work_tree
20
5c08dbbd 21command=
ecda0723 22branch=
d27b876b 23force=
d92a3959 24reference=
70c7ac22 25cached=
48bb3033
GP
26recursive=
27init=
1c244f6e 28files=
31ca3ac3 29nofetch=
32948425 30update=
15fc56a8 31prefix=
70c7ac22 32
f31a522a
ML
33# Resolve relative url by appending to parent's url
34resolve_relative_url ()
35{
98fcf840 36 remote=$(get_default_remote)
8e7e6f39 37 remoteurl=$(git config "remote.$remote.url") ||
4d689320 38 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 39 url="$1"
99b120af 40 remoteurl=${remoteurl%/}
ea640cc6 41 sep=/
f31a522a
ML
42 while test -n "$url"
43 do
44 case "$url" in
45 ../*)
46 url="${url#../}"
ea640cc6
TR
47 case "$remoteurl" in
48 */*)
49 remoteurl="${remoteurl%/*}"
50 ;;
51 *:*)
52 remoteurl="${remoteurl%:*}"
53 sep=:
54 ;;
55 *)
497ee872 56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
ea640cc6
TR
57 ;;
58 esac
f31a522a
ML
59 ;;
60 ./*)
61 url="${url#./}"
62 ;;
63 *)
64 break;;
65 esac
66 done
ea640cc6 67 echo "$remoteurl$sep${url%/}"
f31a522a
ML
68}
69
a7b3269c
DA
70#
71# Get submodule info for registered submodules
72# $@ = path to limit submodule list
73#
74module_list()
75{
313ee0d6
NMC
76 git ls-files --error-unmatch --stage -- "$@" |
77 perl -e '
78 my %unmerged = ();
79 my ($null_sha1) = ("0" x 40);
80 while (<STDIN>) {
81 chomp;
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
85 if ($stage ne "0") {
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
88 }
89 next;
90 }
91 print "$_\n";
92 }
93 '
a7b3269c
DA
94}
95
941987a5
LH
96#
97# Map submodule path to submodule name
98#
99# $1 = path
100#
101module_name()
102{
537601ac 103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64394e3a 104 sm_path="$1"
fe22e542 105 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
a5099bb4 106 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
537601ac 107 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
1e42258a 108 test -z "$name" &&
64394e3a 109 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
1e42258a 110 echo "$name"
941987a5 111}
33aa6fff
LH
112
113#
114# Clone a submodule
115#
23a485e3 116# Prior to calling, cmd_update checks that a possibly existing
ecda0723 117# path is not a git repository.
23a485e3 118# Likewise, cmd_add checks that path does not exist at all,
ecda0723
SV
119# since it is the location of a new submodule.
120#
33aa6fff
LH
121module_clone()
122{
64394e3a 123 sm_path=$1
33aa6fff 124 url=$2
d92a3959 125 reference="$3"
7e60407f
JL
126 quiet=
127 if test -n "$GIT_QUIET"
128 then
129 quiet=-q
130 fi
33aa6fff 131
501770e1
FG
132 gitdir=
133 gitdir_base=
64394e3a
RJ
134 name=$(module_name "$sm_path" 2>/dev/null)
135 test -n "$name" || name="$sm_path"
69c30517 136 base_name=$(dirname "$name")
33aa6fff 137
501770e1 138 gitdir=$(git rev-parse --git-dir)
69c30517
JL
139 gitdir_base="$gitdir/modules/$base_name"
140 gitdir="$gitdir/modules/$name"
501770e1
FG
141
142 if test -d "$gitdir"
d92a3959 143 then
64394e3a 144 mkdir -p "$sm_path"
501770e1 145 rm -f "$gitdir/index"
d92a3959 146 else
501770e1 147 mkdir -p "$gitdir_base"
ea115a0d 148 git clone $quiet -n ${reference:+"$reference"} \
64394e3a
RJ
149 --separate-git-dir "$gitdir" "$url" "$sm_path" ||
150 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
501770e1 151 fi
ea115a0d 152
d75219b4 153 a=$(cd "$gitdir" && pwd)/
64394e3a 154 b=$(cd "$sm_path" && pwd)/
4dce7d9b
JS
155 # normalize Windows-style absolute paths to POSIX-style absolute paths
156 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
157 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
d75219b4
JL
158 # Remove all common leading directories after a sanity check
159 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
160 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
161 fi
162 while test "${a%%/*}" = "${b%%/*}"
163 do
164 a=${a#*/}
165 b=${b#*/}
166 done
167 # Now chop off the trailing '/'s that were added in the beginning
168 a=${a%/}
169 b=${b%/}
170
c5bc42b9
BW
171 # Turn each leading "*/" component into "../"
172 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
64394e3a 173 echo "gitdir: $rel/$a" >"$sm_path/.git"
69c30517 174
c5bc42b9 175 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
64394e3a 176 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
33aa6fff
LH
177}
178
ecda0723
SV
179#
180# Add a new submodule to the working tree, .gitmodules and the index
181#
ec05df35 182# $@ = repo path
ecda0723
SV
183#
184# optional branch is stored in global branch variable
185#
23a485e3 186cmd_add()
ecda0723 187{
5c08dbbd
JH
188 # parse $args after "submodule ... add".
189 while test $# -ne 0
190 do
191 case "$1" in
192 -b | --branch)
193 case "$2" in '') usage ;; esac
194 branch=$2
195 shift
196 ;;
d27b876b
JL
197 -f | --force)
198 force=$1
199 ;;
5c08dbbd 200 -q|--quiet)
2e6a30ef 201 GIT_QUIET=1
5c08dbbd 202 ;;
d92a3959
MT
203 --reference)
204 case "$2" in '') usage ;; esac
205 reference="--reference=$2"
206 shift
207 ;;
208 --reference=*)
209 reference="$1"
210 shift
211 ;;
5c08dbbd
JH
212 --)
213 shift
214 break
215 ;;
216 -*)
217 usage
218 ;;
219 *)
220 break
221 ;;
222 esac
223 shift
224 done
225
ecda0723 226 repo=$1
64394e3a 227 sm_path=$2
ecda0723 228
64394e3a
RJ
229 if test -z "$sm_path"; then
230 sm_path=$(echo "$repo" |
1414e578
JL
231 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232 fi
233
64394e3a 234 if test -z "$repo" -o -z "$sm_path"; then
ecda0723
SV
235 usage
236 fi
237
ec05df35
ML
238 # assure repo is absolute or relative to parent
239 case "$repo" in
240 ./*|../*)
241 # dereference source url relative to parent's url
242 realrepo=$(resolve_relative_url "$repo") || exit
243 ;;
244 *:*|/*)
245 # absolute url
246 realrepo=$repo
247 ;;
248 *)
497ee872 249 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
250 ;;
251 esac
252
db75ada5
MG
253 # normalize path:
254 # multiple //; leading ./; /./; /../; trailing /
64394e3a 255 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
256 sed -e '
257 s|//*|/|g
258 s|^\(\./\)*||
259 s|/\./|/|g
260 :start
261 s|\([^/]*\)/\.\./||
262 tstart
263 s|/*$||
264 ')
64394e3a
RJ
265 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
266 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 267
64394e3a 268 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 269 then
6ff875c5 270 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 271\$sm_path
6ff875c5 272Use -f if you really want to add it." >&2
d27b876b
JL
273 exit 1
274 fi
275
d4264ca3 276 # perhaps the path exists and is already a git repo, else clone it
64394e3a 277 if test -e "$sm_path"
d4264ca3 278 then
64394e3a 279 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
d4264ca3 280 then
64394e3a 281 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 282 else
64394e3a 283 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 284 fi
c2f93917 285
d4264ca3 286 else
d4264ca3 287
64394e3a 288 module_clone "$sm_path" "$realrepo" "$reference" || exit
ea10b60c 289 (
74ae1419 290 clear_local_git_env
64394e3a 291 cd "$sm_path" &&
ea10b60c
BJ
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
502dc5b6 295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
ea10b60c 296 esac
64394e3a 297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 298 fi
64394e3a 299 git config submodule."$sm_path".url "$realrepo"
d4264ca3 300
64394e3a
RJ
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 303
64394e3a
RJ
304 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
31991b02 306 git add --force .gitmodules ||
64394e3a 307 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
308}
309
19a31f9c
ML
310#
311# Execute an arbitrary command sequence in each checked out
312# submodule
313#
314# $@ = command to execute
315#
316cmd_foreach()
317{
1d5bec8b
JH
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
320 do
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
324 ;;
15fc56a8
JH
325 --recursive)
326 recursive=1
327 ;;
1d5bec8b
JH
328 -*)
329 usage
330 ;;
331 *)
332 break
333 ;;
334 esac
335 shift
336 done
337
f030c96d
ÆAB
338 toplevel=$(pwd)
339
4dca1aa6
BC
340 # dup stdin so that it can be restored when running the external
341 # command in the subshell (and a recursive call to this function)
342 exec 3<&0
343
a7b3269c 344 module_list |
64394e3a 345 while read mode sha1 stage sm_path
19a31f9c 346 do
64394e3a 347 if test -e "$sm_path"/.git
19a31f9c 348 then
64394e3a
RJ
349 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
350 name=$(module_name "$sm_path")
15fc56a8 351 (
64394e3a 352 prefix="$prefix$sm_path/"
74ae1419 353 clear_local_git_env
64394e3a
RJ
354 # we make $path available to scripts ...
355 path=$sm_path
356 cd "$sm_path" &&
15fc56a8
JH
357 eval "$@" &&
358 if test -n "$recursive"
359 then
360 cmd_foreach "--recursive" "$@"
361 fi
4dca1aa6 362 ) <&3 3<&- ||
64394e3a 363 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
19a31f9c
ML
364 fi
365 done
366}
367
70c7ac22 368#
211b7f19 369# Register submodules in .git/config
70c7ac22
LH
370#
371# $@ = requested paths (default to all)
372#
23a485e3 373cmd_init()
70c7ac22 374{
5c08dbbd
JH
375 # parse $args after "submodule ... init".
376 while test $# -ne 0
377 do
378 case "$1" in
379 -q|--quiet)
2e6a30ef 380 GIT_QUIET=1
5c08dbbd
JH
381 ;;
382 --)
383 shift
384 break
385 ;;
386 -*)
387 usage
388 ;;
389 *)
390 break
391 ;;
392 esac
393 shift
394 done
395
a7b3269c 396 module_list "$@" |
64394e3a 397 while read mode sha1 stage sm_path
70c7ac22 398 do
211b7f19 399 # Skip already registered paths
64394e3a 400 name=$(module_name "$sm_path") || exit
2cd9de3e
JL
401 if test -z "$(git config "submodule.$name.url")"
402 then
403 url=$(git config -f .gitmodules submodule."$name".url)
404 test -z "$url" &&
64394e3a 405 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
2cd9de3e
JL
406
407 # Possibly a url relative to parent
408 case "$url" in
409 ./*|../*)
410 url=$(resolve_relative_url "$url") || exit
411 ;;
412 esac
413 git config submodule."$name".url "$url" ||
64394e3a 414 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
2cd9de3e 415 fi
70c7ac22 416
2cd9de3e 417 # Copy "update" setting when it is not set yet
32948425
JH
418 upd="$(git config -f .gitmodules submodule."$name".update)"
419 test -z "$upd" ||
2cd9de3e 420 test -n "$(git config submodule."$name".update)" ||
32948425 421 git config submodule."$name".update "$upd" ||
64394e3a 422 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
ca2cedba 423
64394e3a 424 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
70c7ac22
LH
425 done
426}
427
428#
211b7f19 429# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
430#
431# $@ = requested paths (default to all)
432#
23a485e3 433cmd_update()
70c7ac22 434{
5c08dbbd 435 # parse $args after "submodule ... update".
98dbe63d 436 orig_flags=
5c08dbbd
JH
437 while test $# -ne 0
438 do
439 case "$1" in
440 -q|--quiet)
2e6a30ef 441 GIT_QUIET=1
5c08dbbd 442 ;;
be4d2c83 443 -i|--init)
d92a3959 444 init=1
be4d2c83 445 ;;
31ca3ac3 446 -N|--no-fetch)
31ca3ac3
FF
447 nofetch=1
448 ;;
9db31bdf
NMC
449 -f|--force)
450 force=$1
451 ;;
ca2cedba 452 -r|--rebase)
32948425 453 update="rebase"
ca2cedba 454 ;;
d92a3959
MT
455 --reference)
456 case "$2" in '') usage ;; esac
457 reference="--reference=$2"
98dbe63d
KB
458 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
459 shift
d92a3959
MT
460 ;;
461 --reference=*)
462 reference="$1"
d92a3959 463 ;;
42b49178 464 -m|--merge)
42b49178
JH
465 update="merge"
466 ;;
b13fd5c1 467 --recursive)
b13fd5c1
JH
468 recursive=1
469 ;;
efc5fb6a
JH
470 --checkout)
471 update="checkout"
472 ;;
5c08dbbd
JH
473 --)
474 shift
475 break
476 ;;
477 -*)
478 usage
479 ;;
480 *)
481 break
482 ;;
483 esac
98dbe63d
KB
484 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
485 shift
5c08dbbd
JH
486 done
487
d92a3959
MT
488 if test -n "$init"
489 then
490 cmd_init "--" "$@" || return
491 fi
492
1b4735d9 493 cloned_modules=
15ffb7cd
FG
494 module_list "$@" | {
495 err=
64394e3a 496 while read mode sha1 stage sm_path
70c7ac22 497 do
313ee0d6
NMC
498 if test "$stage" = U
499 then
64394e3a 500 echo >&2 "Skipping unmerged submodule $sm_path"
313ee0d6
NMC
501 continue
502 fi
64394e3a 503 name=$(module_name "$sm_path") || exit
5be60078 504 url=$(git config submodule."$name".url)
efc5fb6a
JH
505 if ! test -z "$update"
506 then
507 update_module=$update
508 else
509 update_module=$(git config submodule."$name".update)
510 fi
511
512 if test "$update_module" = "none"
513 then
64394e3a 514 echo "Skipping submodule '$sm_path'"
efc5fb6a
JH
515 continue
516 fi
517
211b7f19 518 if test -z "$url"
70c7ac22
LH
519 then
520 # Only mention uninitialized submodules when its
521 # path have been specified
522 test "$#" != "0" &&
64394e3a 523 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
1c2ef66f 524Maybe you want to use 'update --init'?")"
211b7f19
LH
525 continue
526 fi
527
64394e3a 528 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
211b7f19 529 then
64394e3a 530 module_clone "$sm_path" "$url" "$reference"|| exit
1b4735d9 531 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
532 subsha1=
533 else
64394e3a 534 subsha1=$(clear_local_git_env; cd "$sm_path" &&
5be60078 535 git rev-parse --verify HEAD) ||
64394e3a 536 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
70c7ac22 537 fi
211b7f19 538
70c7ac22
LH
539 if test "$subsha1" != "$sha1"
540 then
9db31bdf
NMC
541 subforce=$force
542 # If we don't already have a -f flag and the submodule has never been checked out
543 if test -z "$subsha1" -a -z "$force"
b9b378a0 544 then
9db31bdf 545 subforce="-f"
b9b378a0 546 fi
31ca3ac3
FF
547
548 if test -z "$nofetch"
549 then
e5f522d6
JL
550 # Run fetch only if $sha1 isn't present or it
551 # is not reachable from a ref.
64394e3a 552 (clear_local_git_env; cd "$sm_path" &&
f5799e05 553 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 554 test -z "$rev") || git-fetch)) ||
64394e3a 555 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
31ca3ac3
FF
556 fi
557
1b4735d9
SO
558 # Is this something we just cloned?
559 case ";$cloned_modules;" in
560 *";$name;"*)
561 # then there is no local change to integrate
562 update_module= ;;
563 esac
564
877449c1 565 must_die_on_failure=
32948425
JH
566 case "$update_module" in
567 rebase)
568 command="git rebase"
64394e3a
RJ
569 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
570 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
877449c1 571 must_die_on_failure=yes
32948425 572 ;;
42b49178
JH
573 merge)
574 command="git merge"
64394e3a
RJ
575 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
576 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
877449c1 577 must_die_on_failure=yes
42b49178 578 ;;
32948425 579 *)
9db31bdf 580 command="git checkout $subforce -q"
64394e3a
RJ
581 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
582 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
32948425
JH
583 ;;
584 esac
70c7ac22 585
64394e3a 586 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 587 then
ff968f03 588 say "$say_msg"
877449c1
JH
589 elif test -n "$must_die_on_failure"
590 then
ff968f03 591 die_with_status 2 "$die_msg"
15ffb7cd 592 else
ff968f03 593 err="${err};$die_msg"
877449c1 594 continue
15ffb7cd 595 fi
70c7ac22 596 fi
b13fd5c1
JH
597
598 if test -n "$recursive"
599 then
64394e3a 600 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
15ffb7cd
FG
601 res=$?
602 if test $res -gt 0
603 then
64394e3a 604 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
15ffb7cd
FG
605 if test $res -eq 1
606 then
ff968f03 607 err="${err};$die_msg"
15ffb7cd
FG
608 continue
609 else
ff968f03 610 die_with_status $res "$die_msg"
15ffb7cd
FG
611 fi
612 fi
b13fd5c1 613 fi
70c7ac22 614 done
15ffb7cd
FG
615
616 if test -n "$err"
617 then
618 OIFS=$IFS
619 IFS=';'
620 for e in $err
621 do
622 if test -n "$e"
623 then
624 echo >&2 "$e"
625 fi
626 done
627 IFS=$OIFS
628 exit 1
629 fi
630 }
70c7ac22
LH
631}
632
bffe71f4
EM
633set_name_rev () {
634 revname=$( (
74ae1419 635 clear_local_git_env
bffe71f4 636 cd "$1" && {
5be60078
JH
637 git describe "$2" 2>/dev/null ||
638 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
639 git describe --contains "$2" 2>/dev/null ||
640 git describe --all --always "$2"
bffe71f4
EM
641 }
642 ) )
643 test -z "$revname" || revname=" ($revname)"
644}
28f9af5d
PY
645#
646# Show commit summary for submodules in index or working tree
647#
648# If '--cached' is given, show summary between index and given commit,
649# or between working tree and given commit
650#
651# $@ = [commit (default 'HEAD'),] requested paths (default all)
652#
653cmd_summary() {
f2dc06a3 654 summary_limit=-1
d0f64dd4 655 for_status=
1c244f6e 656 diff_cmd=diff-index
f2dc06a3 657
28f9af5d
PY
658 # parse $args after "submodule ... summary".
659 while test $# -ne 0
660 do
661 case "$1" in
662 --cached)
663 cached="$1"
664 ;;
1c244f6e
JL
665 --files)
666 files="$1"
667 ;;
d0f64dd4
PY
668 --for-status)
669 for_status="$1"
670 ;;
f2dc06a3
PY
671 -n|--summary-limit)
672 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
673 then
674 :
675 else
676 usage
677 fi
678 shift
679 ;;
28f9af5d
PY
680 --)
681 shift
682 break
683 ;;
684 -*)
685 usage
686 ;;
687 *)
688 break
689 ;;
690 esac
691 shift
692 done
bffe71f4 693
f2dc06a3
PY
694 test $summary_limit = 0 && return
695
3deea89c 696 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
697 then
698 head=$rev
caa9c3ca 699 test $# = 0 || shift
3deea89c
JH
700 elif test -z "$1" -o "$1" = "HEAD"
701 then
14e940d7
JH
702 # before the first commit: compare with an empty tree
703 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 704 test -z "$1" || shift
28f9af5d 705 else
3deea89c 706 head="HEAD"
28f9af5d
PY
707 fi
708
1c244f6e
JL
709 if [ -n "$files" ]
710 then
711 test -n "$cached" &&
b9b9c22f 712 die "$(gettext -- "--cached cannot be used with --files")"
1c244f6e
JL
713 diff_cmd=diff-files
714 head=
715 fi
716
28f9af5d
PY
717 cd_to_toplevel
718 # Get modified modules cared by user
18076502 719 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 720 sane_egrep '^:([0-7]* )?160000' |
28f9af5d
PY
721 while read mod_src mod_dst sha1_src sha1_dst status name
722 do
723 # Always show modules deleted or type-changed (blob<->module)
724 test $status = D -o $status = T && echo "$name" && continue
725 # Also show added or modified modules which are checked out
726 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
727 echo "$name"
728 done
729 )
1cb639e6 730
d0f64dd4
PY
731 test -z "$modules" && return
732
18076502 733 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 734 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
735 cut -c2- |
736 while read mod_src mod_dst sha1_src sha1_dst status name
737 do
738 if test -z "$cached" &&
739 test $sha1_dst = 0000000000000000000000000000000000000000
740 then
741 case "$mod_dst" in
742 160000)
743 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
744 ;;
745 100644 | 100755 | 120000)
746 sha1_dst=$(git hash-object $name)
747 ;;
748 000000)
749 ;; # removed
750 *)
751 # unexpected type
6ff875c5 752 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
753 continue ;;
754 esac
755 fi
756 missing_src=
757 missing_dst=
758
759 test $mod_src = 160000 &&
30353a40 760 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
761 missing_src=t
762
763 test $mod_dst = 160000 &&
30353a40 764 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 765 missing_dst=t
bffe71f4 766
1cb639e6
PY
767 total_commits=
768 case "$missing_src,$missing_dst" in
769 t,)
f62f8212 770 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
1cb639e6
PY
771 ;;
772 ,t)
f62f8212 773 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
774 ;;
775 t,t)
f62f8212 776 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
777 ;;
778 *)
779 errmsg=
780 total_commits=$(
781 if test $mod_src = 160000 -a $mod_dst = 160000
782 then
783 range="$sha1_src...$sha1_dst"
784 elif test $mod_src = 160000
785 then
786 range=$sha1_src
787 else
788 range=$sha1_dst
789 fi
790 GIT_DIR="$name/.git" \
b0e621ad 791 git rev-list --first-parent $range -- | wc -l
1cb639e6 792 )
eed35595 793 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
794 ;;
795 esac
796
797 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
798 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
799 if test $status = T
800 then
b3e73449
ÆAB
801 blob="$(gettext "blob")"
802 submodule="$(gettext "submodule")"
1cb639e6
PY
803 if test $mod_dst = 160000
804 then
b3e73449 805 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 806 else
b3e73449 807 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
808 fi
809 else
810 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
811 fi
812 if test -n "$errmsg"
813 then
814 # Don't give error msg for modification whose dst is not submodule
815 # i.e. deleted or changed to blob
816 test $mod_dst = 160000 && echo "$errmsg"
817 else
818 if test $mod_src = 160000 -a $mod_dst = 160000
819 then
f2dc06a3
PY
820 limit=
821 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 822 GIT_DIR="$name/.git" \
f2dc06a3 823 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
824 --first-parent $sha1_src...$sha1_dst
825 elif test $mod_dst = 160000
826 then
827 GIT_DIR="$name/.git" \
828 git log --pretty='format: > %s' -1 $sha1_dst
829 else
830 GIT_DIR="$name/.git" \
831 git log --pretty='format: < %s' -1 $sha1_src
832 fi
833 echo
834 fi
835 echo
d0f64dd4
PY
836 done |
837 if test -n "$for_status"; then
f17a5d34 838 if [ -n "$files" ]; then
6ff875c5 839 gettextln "# Submodules changed but not updated:"
f17a5d34 840 else
6ff875c5 841 gettextln "# Submodule changes to be committed:"
f17a5d34 842 fi
d0f64dd4
PY
843 echo "#"
844 sed -e 's|^|# |' -e 's|^# $|#|'
845 else
846 cat
847 fi
28f9af5d 848}
70c7ac22 849#
941987a5 850# List all submodules, prefixed with:
70c7ac22
LH
851# - submodule not initialized
852# + different revision checked out
853#
854# If --cached was specified the revision in the index will be printed
855# instead of the currently checked out revision.
856#
857# $@ = requested paths (default to all)
858#
23a485e3 859cmd_status()
70c7ac22 860{
5c08dbbd 861 # parse $args after "submodule ... status".
98dbe63d 862 orig_flags=
5c08dbbd
JH
863 while test $# -ne 0
864 do
865 case "$1" in
866 -q|--quiet)
2e6a30ef 867 GIT_QUIET=1
5c08dbbd
JH
868 ;;
869 --cached)
870 cached=1
871 ;;
64b19ffe
JH
872 --recursive)
873 recursive=1
874 ;;
5c08dbbd
JH
875 --)
876 shift
877 break
878 ;;
879 -*)
880 usage
881 ;;
882 *)
883 break
884 ;;
885 esac
98dbe63d 886 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
5c08dbbd
JH
887 shift
888 done
889
a7b3269c 890 module_list "$@" |
64394e3a 891 while read mode sha1 stage sm_path
70c7ac22 892 do
64394e3a 893 name=$(module_name "$sm_path") || exit
5be60078 894 url=$(git config submodule."$name".url)
64394e3a 895 displaypath="$prefix$sm_path"
313ee0d6
NMC
896 if test "$stage" = U
897 then
898 say "U$sha1 $displaypath"
899 continue
900 fi
64394e3a 901 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
70c7ac22 902 then
64b19ffe 903 say "-$sha1 $displaypath"
70c7ac22
LH
904 continue;
905 fi
64394e3a
RJ
906 set_name_rev "$sm_path" "$sha1"
907 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 908 then
64b19ffe 909 say " $sha1 $displaypath$revname"
70c7ac22
LH
910 else
911 if test -z "$cached"
912 then
64394e3a
RJ
913 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
914 set_name_rev "$sm_path" "$sha1"
70c7ac22 915 fi
64b19ffe
JH
916 say "+$sha1 $displaypath$revname"
917 fi
918
919 if test -n "$recursive"
920 then
921 (
922 prefix="$displaypath/"
74ae1419 923 clear_local_git_env
64394e3a 924 cd "$sm_path" &&
a7eff1a8 925 eval cmd_status "$orig_args"
64b19ffe 926 ) ||
64394e3a 927 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
928 fi
929 done
930}
2327f61e
DA
931#
932# Sync remote urls for submodules
933# This makes the value for remote.$remote.url match the value
934# specified in .gitmodules.
935#
936cmd_sync()
937{
938 while test $# -ne 0
939 do
940 case "$1" in
941 -q|--quiet)
2e6a30ef 942 GIT_QUIET=1
2327f61e
DA
943 shift
944 ;;
945 --)
946 shift
947 break
948 ;;
949 -*)
950 usage
951 ;;
952 *)
953 break
954 ;;
955 esac
956 done
957 cd_to_toplevel
958 module_list "$@" |
64394e3a 959 while read mode sha1 stage sm_path
2327f61e 960 do
64394e3a 961 name=$(module_name "$sm_path")
2327f61e 962 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
963
964 # Possibly a url relative to parent
965 case "$url" in
966 ./*|../*)
967 url=$(resolve_relative_url "$url") || exit
968 ;;
969 esac
970
ccee6086 971 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 972 then
0591c0a5 973 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
ccee6086
JH
974 git config submodule."$name".url "$url"
975
64394e3a 976 if test -e "$sm_path"/.git
ccee6086
JH
977 then
978 (
979 clear_local_git_env
64394e3a 980 cd "$sm_path"
ccee6086
JH
981 remote=$(get_default_remote)
982 git config remote."$remote".url "$url"
983 )
984 fi
2327f61e
DA
985 fi
986 done
987}
70c7ac22 988
5c08dbbd
JH
989# This loop parses the command line arguments to find the
990# subcommand name to dispatch. Parsing of the subcommand specific
991# options are primarily done by the subcommand implementations.
992# Subcommand specific options such as --branch and --cached are
993# parsed here as well, for backward compatibility.
994
995while test $# != 0 && test -z "$command"
70c7ac22
LH
996do
997 case "$1" in
2327f61e 998 add | foreach | init | update | status | summary | sync)
5c08dbbd 999 command=$1
70c7ac22
LH
1000 ;;
1001 -q|--quiet)
2e6a30ef 1002 GIT_QUIET=1
70c7ac22 1003 ;;
ecda0723
SV
1004 -b|--branch)
1005 case "$2" in
1006 '')
1007 usage
1008 ;;
1009 esac
1010 branch="$2"; shift
1011 ;;
70c7ac22 1012 --cached)
28f9af5d 1013 cached="$1"
70c7ac22
LH
1014 ;;
1015 --)
1016 break
1017 ;;
1018 -*)
1019 usage
1020 ;;
1021 *)
1022 break
1023 ;;
1024 esac
1025 shift
1026done
1027
5c08dbbd
JH
1028# No command word defaults to "status"
1029test -n "$command" || command=status
1030
1031# "-b branch" is accepted only by "add"
1032if test -n "$branch" && test "$command" != add
1033then
ecda0723 1034 usage
5c08dbbd
JH
1035fi
1036
28f9af5d
PY
1037# "--cached" is accepted only by "status" and "summary"
1038if test -n "$cached" && test "$command" != status -a "$command" != summary
5c08dbbd 1039then
70c7ac22 1040 usage
5c08dbbd
JH
1041fi
1042
1043"cmd_$command" "$@"